# Uses of Class
javajs.util.M4

Packages that use M4
Package
Description
javajs.util
org.jmol.adapter.readers.cif
org.jmol.adapter.smarter
org.jmol.api
org.jmol.atomdata
org.jmol.export
org.jmol.g3d
Provides a software implementation of complete 3D graphics engine for rendering molecules and associated shapes.
org.jmol.jvxl.readers
org.jmol.modelset
org.jmol.script
org.jmol.scriptext
org.jmol.shape
org.jmol.shapespecial
org.jmol.shapesurface
org.jmol.symmetry
org.jmol.util
org.jmol.viewer

## Uses of M4 in javajs.util

Methods in javajs.util that return M4
Modifier and Type
Method
Description
`M4`
M4.`invert()`
Sets the value of this matrix to its inverse.
`static M4`
M4.`newA16(float[] v)`
Constructs and initializes a Matrix4f from the specified 16 element array.
`static M4`
M4.`newM4(M4 m1)`
Constructs a new matrix with the same values as the Matrix4f parameter.
`static M4`
M4.`newMV(M3 m1, T3 t)`
Constructs and initializes a Matrix4f from the rotation matrix and translation.
`M4`
M4.`round(float f)`
`M4`
M4.`setAsXYRotation(float angle)`
Sets the value of this matrix to a rotation matrix about the w axis by the passed angle.
`M4`
M4.`setAsXZRotation(float angle)`
Sets the value of this matrix to a rotation matrix about the w axis by the passed angle.
`M4`
M4.`setAsYZRotation(float angle)`
Sets the value of this matrix to a rotation matrix about the w axis by the passed angle.
`M4`
M4.`setM4(M4 m1)`
Sets the value of this matrix to a copy of the passed matrix m1.
Methods in javajs.util with parameters of type M4
Modifier and Type
Method
Description
`static float`
Measure.`getTransformMatrix4(Lst<P3> ptsA, Lst<P3> ptsB, M4 m, P3 centerA)`
Fills a 4x4 matrix with rotation-translation of mapped points A to B.
`void`
M4.`mul(M4 m1)`
Sets the value of this matrix to the result of multiplying itself with matrix m1.
`void`
M4.`mul2(M4 m1, M4 m2)`
Sets the value of this matrix to the result of multiplying the two argument matrices together.
`static M4`
M4.`newM4(M4 m1)`
Constructs a new matrix with the same values as the Matrix4f parameter.
`M4`
M4.`setM4(M4 m1)`
Sets the value of this matrix to a copy of the passed matrix m1.
`void`
M4.`sub(M4 m1)`
Sets the value of this matrix to the matrix difference of itself and matrix m1 (this = this - m1).
`static Lst<P3>`
Measure.`transformPoints(Lst<P3> vPts, M4 m4, P3 center)`

## Uses of M4 in org.jmol.adapter.readers.cif

Methods in org.jmol.adapter.readers.cif with parameters of type M4
Modifier and Type
Method
Description
`protected void`
MMCifReader.`addMatrix(String id, M4 m4, boolean isNCS)`

## Uses of M4 in org.jmol.adapter.smarter

Fields in org.jmol.adapter.smarter with type parameters of type M4
Modifier and Type
Field
Description
`Lst<M4>`
AtomSetCollectionReader.`lstNCS`
Methods in org.jmol.adapter.smarter with parameters of type M4
Modifier and Type
Method
Description
`void`
XtalSymmetry.FileSymmetry.`toFractionalM(M4 m)`

## Uses of M4 in org.jmol.api

Methods in org.jmol.api that return M4
Modifier and Type
Method
Description
`M4[]`
SymmetryInterface.`getAdditionalOperations()`
`M4`
SymmetryInterface.`getSpaceGroupOperation(int i)`
`M4[]`
SymmetryInterface.`getSymmetryOperations()`
`M4`
SymmetryInterface.`getTransform(P3 fracA, P3 fracB, boolean debug)`
`M4`
SymmetryInterface.`saveOrRetrieveTransformMatrix(M4 trmat)`
`M4`
SymmetryInterface.`staticGetMatrixTransform(String cleg, Object retLstOrMap)`
Methods in org.jmol.api with parameters of type M4
Modifier and Type
Method
Description
`int`
SymmetryInterface.`addBioMoleculeOperation(M4 mat, boolean isReverse)`
`Object`
SymmetryInterface.`convertTransform(String transform, M4 trm)`
`void`
JmolRendererInterface.`fillEllipsoid(P3 center, P3[] points, int x, int y, int z, int diameter, M3 mToEllipsoidal, double[] coef, M4 mDeriv, int selectedOctant, P3[] octantPoints)`
`void`
SymmetryInterface.`getEquivPointList(int nIgnore, String flags, M4[] opsCtr, float packing, Lst<Point3fi> pts, SymmetryInterface uc)`
`T3[]`
SymmetryInterface.`getV0abc(Object def, M4 m)`
`void`
SymmetryInterface.`newSpaceGroupPoint(P3 pt, int i, M4 o, int transX, int transY, int transZ, P3 retPoint)`
`M4`
SymmetryInterface.`saveOrRetrieveTransformMatrix(M4 trmat)`
`String`
SymmetryInterface.`staticGetTransformABC(M4 transform, boolean normalize)`

## Uses of M4 in org.jmol.atomdata

Methods in org.jmol.atomdata with parameters of type M4
Modifier and Type
Method
Description
`void`
AtomData.`transformXYZ(M4 mat, BS bs)`
allow for transformed XYZ

## Uses of M4 in org.jmol.export

Fields in org.jmol.export declared as M4
Modifier and Type
Field
Description
`protected M4`
__CartesianExporter.`sphereMatrix`
Methods in org.jmol.export with parameters of type M4
Modifier and Type
Method
Description
`void`
Export3D.`fillEllipsoid(P3 center, P3[] points, int x, int y, int z, int diameter, M3 mToEllipsoidal, double[] coef, M4 mDeriv, int selectedOctant, P3[] octantPoints)`
`protected void`
__CartesianExporter.`setSphereMatrix(T3 center, float rx, float ry, float rz, A4 a, M4 sphereMatrix)`

## Uses of M4 in org.jmol.g3d

Methods in org.jmol.g3d with parameters of type M4
Modifier and Type
Method
Description
`void`
Graphics3D.`fillEllipsoid(P3 center, P3[] points, int x, int y, int z, int diameter, M3 mToEllipsoidal, double[] coef, M4 mDeriv, int selectedOctant, P3[] octantPoints)`

## Uses of M4 in org.jmol.jvxl.readers

Fields in org.jmol.jvxl.readers declared as M4
Modifier and Type
Field
Description
`M4`
Parameters.`modelInvRotation`

## Uses of M4 in org.jmol.modelset

Fields in org.jmol.modelset declared as M4
Modifier and Type
Field
Description
`M4`
Model.`mat4`
mat4 tracks the rotation/translation of the full model using rotateSelected or translateSelected
Methods in org.jmol.modelset that return M4
Modifier and Type
Method
Description
`M4[]`
ModelSet.`getSymMatrices(int modelIndex)`
Methods in org.jmol.modelset with parameters of type M4
Modifier and Type
Method
Description
`void`
ModelSet.`moveAtoms(M4 m4, M3 mNew, M3 rotation, V3 translation, BS bs, P3 center, boolean isInternal, boolean translationOnly)`
`void`
ModelSet.`recalculatePositionDependentQuantities(BS bsAtoms, M4 mat)`

## Uses of M4 in org.jmol.script

Methods in org.jmol.script that return M4
Modifier and Type
Method
Description
`static M4`
ScriptMathProcessor.`getMatrix4f(M3 matRotate, T3 vTranslate)`
Methods in org.jmol.script with parameters of type M4
Modifier and Type
Method
Description
`boolean`
ScriptMathProcessor.`addXM4(M4 x)`
`static double`
ScriptParam.`getTransformMatrix4(Lst<P3> ptsA, Lst<P3> ptsB, M4 m, P3 centerA)`
Fills a 4x4 matrix with rotation-translation of mapped points A to B.
`static Lst<P3>`
ScriptParam.`transformPoints(Lst<P3> vPts, M4 m4, P3 center)`

## Uses of M4 in org.jmol.scriptext

Methods in org.jmol.scriptext with parameters of type M4
Modifier and Type
Method
Description
`float`
SmilesExt.`getSmilesCorrelation(BS bsA, BS bsB, String smiles, Lst<P3> ptsA, Lst<P3> ptsB, M4 m4, Lst<BS> vReturn, boolean asMap, int[][] mapSet, P3 center, boolean bestMap, int flags)`
The major interface to org.jmol.smiles, this method allows for a wide variety of correlation functionality.
`float`
SmilesExt.`mapPolyhedra(int i1, int i2, boolean isSmiles, M4 m)`

## Uses of M4 in org.jmol.shape

Fields in org.jmol.shape declared as M4
Modifier and Type
Field
Description
`M4[]`
Mesh.`symops`

## Uses of M4 in org.jmol.shapespecial

Methods in org.jmol.shapespecial with parameters of type M4
Modifier and Type
Method
Description
`static void`
Ellipsoid.`getEquationForQuadricWithCenter(float x, float y, float z, M3 mToElliptical, V3 vTemp, M3 mTemp, double[] coef, M4 mDeriv)`

## Uses of M4 in org.jmol.shapesurface

Methods in org.jmol.shapesurface with parameters of type M4
Modifier and Type
Method
Description
`void`
IsosurfaceMesh.`updateCoordinates(M4 m, BS bs)`
bs will be null if this is a set from the new isosurface MOVE [mat4] command

## Uses of M4 in org.jmol.symmetry

Subclasses of M4 in org.jmol.symmetry
Modifier and Type
Class
Description
`class`
`SymmetryOperation`
Fields in org.jmol.symmetry declared as M4
Modifier and Type
Field
Description
`M4`
CLEG.ClegData.`trMat`
Methods in org.jmol.symmetry that return M4
Modifier and Type
Method
Description
`M4`
CLEG.ClegData.`addSGTransform(String tr, String what)`
`M4[]`
Symmetry.`getAdditionalOperations()`
`static M4`
SymmetryOperation.`getMatrixFromXYZ(String xyz, float[] v, boolean halfOrLess)`
`static M4`
SymmetryOperation.`getMatrixFromXYZScaled(String xyz, float[] v, boolean halfOrLess)`
`M4`
HallInfo.HallReceiver.`getMatrixOperation(int k)`
Get the 4x4 matrix for the kth operation.
`M4`
SpaceGroup.`getMatrixOperation(int i)`
`M4`
Symmetry.`getSpaceGroupOperation(int i)`
`M4`
Symmetry.`getTransform(P3 fracA, P3 fracB, boolean best)`
`M4`
SymmetryDesc.`getTransform(UnitCell uc, SymmetryOperation[] ops, P3 fracA, P3 fracB, boolean best)`
`M4`
CLEG.ClegData.`matFor(String trm)`
`M4`
Symmetry.`saveOrRetrieveTransformMatrix(M4 trm)`
Saved by CLEG.assignSpaceGroup; retrieved by SpaceGroupFinder.
`M4`
Symmetry.`staticGetMatrixTransform(String cleg, Object retLstOrMap)`
`static M4`
UnitCell.`toTrm(String transform, M4 trm)`
Methods in org.jmol.symmetry with parameters of type M4
Modifier and Type
Method
Description
`String`
CLEG.ClegData.`abcFor(M4 trm)`
`int`
Symmetry.`addBioMoleculeOperation(M4 mat, boolean isReverse)`
`boolean`
HallInfo.HallReceiver.`addHallOperationCheckDuplicates(M4 operation)`
Add a (possibly) new operation, checking for duplicates.
`boolean`
SpaceGroup.`addHallOperationCheckDuplicates(M4 operation)`
`String`
CLEG.ClegData.`calculate(M4 trm0)`
`Object`
Symmetry.`convertTransform(String transform, M4 trm)`
A general method to handle converstions between string-based and matrix-based representations of transformations.
`void`
Symmetry.`getEquivPointList(int nInitial, String flags, M4[] opsCtr, float packing, Lst<Point3fi> pts, SymmetryInterface uc)`
Load a list of initial current points, and one or more starting points with equivalent points.
`static T3[]`
UnitCell.`getMatrixAndUnitCell(Viewer vwr, SimpleUnitCell uc, Object def, M4 retMatrix)`
`static String`
SymmetryOperation.`getTransformABC(M4 transform, boolean normalize)`
This method properly transposes the matrix for ABC format, converting columns to rows before passing the information to getXYZFromMatrixFrac(...,"ABC").
`static String`
SymmetryOperation.`getTransformABCd(M4 transform, boolean normalize, boolean fractionAsDecimal)`
`static String`
SymmetryOperation.`getTransformUVW(M4 spin)`
`static String`
SymmetryOperation.`getTransformXYZ(M4 op)`
`T3[]`
Symmetry.`getV0abc(Object def, M4 retMatrix)`
`static final String`
SymmetryOperation.`getXYZFromMatrix(M4 mat, boolean is12ths, boolean allPositive, boolean halfOrLess)`
`static boolean`
SymmetryOperation.`isTranslation(M4 op)`
`void`
Symmetry.`newSpaceGroupPoint(P3 pt, int i, M4 o, int transX, int transY, int transZ, P3 retPoint)`
`static void`
SymmetryOperation.`normalizeOperationToCentroid(int dim, M4 m, P3[] fracPts, int i0, int n)`
Adjust the translation for this operator so that it moves the center of mass of the full set of atoms into the cell.
`M4`
Symmetry.`saveOrRetrieveTransformMatrix(M4 trm)`
Saved by CLEG.assignSpaceGroup; retrieved by SpaceGroupFinder.
`String`
Symmetry.`staticGetTransformABC(M4 transform, boolean normalize)`
`static M4`
UnitCell.`toTrm(String transform, M4 trm)`
`void`
Symmetry.`transformUnitCell(M4 trm)`
Transform the unit cell based on the calculated transformation matrix.

## Uses of M4 in org.jmol.util

Fields in org.jmol.util declared as M4
Modifier and Type
Field
Description
`M4`
MeshSurface.`mat4`
`M4`
SimpleUnitCell.`matrixCartesianToFractional`
`protected M4`
SimpleUnitCell.`matrixCtoFNoOffset`
`M4`
SimpleUnitCell.`matrixFractionalToCartesian`
`protected M4`
SimpleUnitCell.`matrixFtoCNoOffset`
Methods in org.jmol.util with parameters of type M4
Modifier and Type
Method
Description
`int`
Shader.`getEllipsoidShade(float x, float y, float z, int radius, M4 mDeriv)`
`void`
SimpleUnitCell.`toFractionalM(M4 m)`

## Uses of M4 in org.jmol.viewer

Fields in org.jmol.viewer declared as M4
Modifier and Type
Field
Description
`protected final M4`
TransformManager.`matrixTemp`
`final M4`
TransformManager.`matrixTransform`
`final M4`
TransformManager.`matrixTransformInv`
Methods in org.jmol.viewer with parameters of type M4
Modifier and Type
Method
Description
`void`
Viewer.`moveAtoms(M4 m4, M3 mNew, M3 rotation, V3 translation, P3 center, boolean isInternal, BS bsAtoms, boolean translationOnly, boolean useModelKit)`
`void`
ShapeManager.`notifyAtomPositionsChanged(int baseModel, BS bs, M4 mat)`
`boolean`
Viewer.`rotateAboutPointsInternal(JmolScriptEvaluator eval, P3 point1, P3 point2, float degreesPerSecond, float endDegrees, boolean isSpin, BS bsSelected, V3 translation, Lst<P3> finalPoints, float[] dihedralList, M3 vectorMatrix, M4 m4, boolean useModelKit, P3[][] centerAndPoints)`
`void`
TransformManager.`rotateAxisAngleRadiansInternal(float radians, BS bsAtoms, M4 m4, boolean useModelKit)`
`void`
TransformManager4D.`setAsBallRotation(M4 m, float scale, float dx, float dy, float dz)`
4D ball rotation from nominal dx, dy, dz motion.